Index: unk/sources/HeuristicLab.Constraints/FalseConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/FalseConstraint.cs	(revision 892)
+++ 	(revision )
@@ -1,48 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Constraints {
-  public class FalseConstraint : ConstraintBase {
-    public override string Description {
-      get { return "This constraint is always false."; }
-    }
-
-    public override IView CreateView() {
-      return new FalseConstraintView(this);
-    }
-
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
-      FalseConstraint clone = new FalseConstraint();
-      clonedObjects.Add(Guid, clone);
-      return clone;
-    }
-
-    public override bool Check(IItem data) {
-      return false;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/FalseConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/FalseConstraintView.Designer.cs	(revision 892)
+++ 	(revision )
@@ -1,76 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Constraints {
-  partial class FalseConstraintView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.falseLabel = new System.Windows.Forms.Label();
-      this.SuspendLayout();
-      // 
-      // falseLabel
-      // 
-      this.falseLabel.Anchor = System.Windows.Forms.AnchorStyles.Top;
-      this.falseLabel.AutoSize = true;
-      this.falseLabel.Location = new System.Drawing.Point(42, 0);
-      this.falseLabel.Name = "falseLabel";
-      this.falseLabel.Size = new System.Drawing.Size(32, 13);
-      this.falseLabel.TabIndex = 0;
-      this.falseLabel.Text = "False";
-      // 
-      // FalseConstraintView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.falseLabel);
-      this.Name = "FalseConstraintView";
-      this.Size = new System.Drawing.Size(117, 28);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label falseLabel;
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/FalseConstraintView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/FalseConstraintView.cs	(revision 892)
+++ 	(revision )
@@ -1,46 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Constraints {
-  public partial class FalseConstraintView : ViewBase {
-    public FalseConstraint FalseConstraint {
-      get { return (FalseConstraint)Item; }
-      set { base.Item = value; }
-    }
-    public FalseConstraintView() {
-      InitializeComponent();
-    }
-
-    public FalseConstraintView(FalseConstraint falseConstraint)
-      : this() {
-      FalseConstraint = falseConstraint;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/FalseConstraintView.resx
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/FalseConstraintView.resx	(revision 892)
+++ 	(revision )
@@ -1,120 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: /trunk/sources/HeuristicLab.Constraints/HeuristicLab.Constraints.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/HeuristicLab.Constraints.csproj	(revision 892)
+++ /trunk/sources/HeuristicLab.Constraints/HeuristicLab.Constraints.csproj	(revision 893)
@@ -84,10 +84,4 @@
     </Compile>
     <Compile Include="IntBoundedConstraint.cs" />
-    <Compile Include="FalseConstraintView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="FalseConstraintView.Designer.cs">
-      <DependentUpon>FalseConstraintView.cs</DependentUpon>
-    </Compile>
     <Compile Include="IntBoundedConstraintView.cs">
       <SubType>UserControl</SubType>
@@ -125,5 +119,4 @@
       <DependentUpon>OrConstraintView.cs</DependentUpon>
     </Compile>
-    <Compile Include="FalseConstraint.cs" />
     <Compile Include="SubOperatorsConstraintAnalyser.cs" />
     <Compile Include="SubOperatorsTypeConstraint.cs" />
@@ -134,13 +127,6 @@
       <DependentUpon>SubOperatorsTypeConstraintView.cs</DependentUpon>
     </Compile>
-    <Compile Include="TrueConstraint.cs" />
     <Compile Include="HeuristicLabConstraintsPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="TrueConstraintView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="TrueConstraintView.Designer.cs">
-      <DependentUpon>TrueConstraintView.cs</DependentUpon>
-    </Compile>
     <Compile Include="VariableComparisonConstraint.cs" />
     <Compile Include="VariableComparisonConstraintView.cs">
@@ -182,8 +168,4 @@
       <DependentUpon>DoubleBoundedConstraintView.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="FalseConstraintView.resx">
-      <SubType>Designer</SubType>
-      <DependentUpon>FalseConstraintView.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="IntBoundedConstraintView.resx">
       <SubType>Designer</SubType>
@@ -209,8 +191,4 @@
       <DependentUpon>SubOperatorsTypeConstraintView.cs</DependentUpon>
       <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="TrueConstraintView.resx">
-      <SubType>Designer</SubType>
-      <DependentUpon>TrueConstraintView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="VariableComparisonConstraintView.resx">
Index: /trunk/sources/HeuristicLab.Constraints/NotConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/NotConstraint.cs	(revision 892)
+++ /trunk/sources/HeuristicLab.Constraints/NotConstraint.cs	(revision 893)
@@ -44,9 +44,8 @@
     public NotConstraint()
       : base() {
-      subConstraint = new FalseConstraint();
     }
 
     public override bool Check(IItem data) {
-      return !subConstraint.Check(data);
+      return (subConstraint == null) || (!subConstraint.Check(data));
     }
 
@@ -58,5 +57,6 @@
       NotConstraint clone = new NotConstraint();
       clonedObjects.Add(Guid, clone);
-      clone.SubConstraint = (ConstraintBase)SubConstraint.Clone();
+      if (subConstraint != null)
+        clone.SubConstraint = (ConstraintBase)SubConstraint.Clone();
       return clone;
     }
@@ -65,6 +65,8 @@
     public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
       XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      XmlNode sub = PersistenceManager.Persist("SubConstraint", SubConstraint, document, persistedObjects);
-      node.AppendChild(sub);
+      if (subConstraint != null) {
+        XmlNode sub = PersistenceManager.Persist("SubConstraint", SubConstraint, document, persistedObjects);
+        node.AppendChild(sub);
+      }
       return node;
     }
@@ -72,5 +74,7 @@
     public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
       base.Populate(node, restoredObjects);
-      subConstraint = (ConstraintBase)PersistenceManager.Restore(node.SelectSingleNode("SubConstraint"), restoredObjects);
+      XmlNode subNode =  node.SelectSingleNode("SubConstraint");
+      if(subNode!=null) 
+        subConstraint = (ConstraintBase)PersistenceManager.Restore(subNode, restoredObjects);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Constraints/NotConstraintView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/NotConstraintView.cs	(revision 892)
+++ /trunk/sources/HeuristicLab.Constraints/NotConstraintView.cs	(revision 893)
@@ -99,5 +99,5 @@
           NotConstraint.SubConstraint = (ConstraintBase)Activator.CreateInstance(itemTypes[subConstraintComboBox.SelectedIndex]);
         } catch (Exception) {
-          NotConstraint.SubConstraint = new FalseConstraint();
+          NotConstraint.SubConstraint = null;
         }
       }
Index: unk/sources/HeuristicLab.Constraints/TrueConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/TrueConstraint.cs	(revision 892)
+++ 	(revision )
@@ -1,48 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Constraints {
-  public class TrueConstraint : ConstraintBase {
-    public override string Description {
-      get { return "This constraint is always true."; }
-    }
-
-    public override IView CreateView() {
-      return new TrueConstraintView(this);
-    }
-
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
-      TrueConstraint clone = new TrueConstraint();
-      clonedObjects.Add(Guid, clone);
-      return clone;
-    }
-
-    public override bool Check(IItem data) {
-      return true;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/TrueConstraintView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/TrueConstraintView.Designer.cs	(revision 892)
+++ 	(revision )
@@ -1,76 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Constraints {
-  partial class TrueConstraintView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.trueLabel = new System.Windows.Forms.Label();
-      this.SuspendLayout();
-      // 
-      // trueLabel
-      // 
-      this.trueLabel.Anchor = System.Windows.Forms.AnchorStyles.Top;
-      this.trueLabel.AutoSize = true;
-      this.trueLabel.Location = new System.Drawing.Point(36, 0);
-      this.trueLabel.Name = "trueLabel";
-      this.trueLabel.Size = new System.Drawing.Size(29, 13);
-      this.trueLabel.TabIndex = 0;
-      this.trueLabel.Text = "True";
-      // 
-      // TrueConstraintView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.trueLabel);
-      this.Name = "TrueConstraintView";
-      this.Size = new System.Drawing.Size(100, 31);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label trueLabel;
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/TrueConstraintView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/TrueConstraintView.cs	(revision 892)
+++ 	(revision )
@@ -1,46 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Constraints {
-  public partial class TrueConstraintView : ViewBase {
-    public TrueConstraint TrueConstraint {
-      get { return (TrueConstraint)Item; }
-      set { base.Item = value; }
-    }
-    public TrueConstraintView() {
-      InitializeComponent();
-    }
-
-    public TrueConstraintView(TrueConstraint trueConstraint)
-      : this() {
-      TrueConstraint = trueConstraint;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Constraints/TrueConstraintView.resx
===================================================================
--- /trunk/sources/HeuristicLab.Constraints/TrueConstraintView.resx	(revision 892)
+++ 	(revision )
@@ -1,120 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>